'
' Logistic Formula
'
' written by   scott dhomas trenn
'              797 Mitchell Street, Fredericton, NB, E3B 3S8, CANADA
'              INTERNET: wilkie@jupiter.sun.csd.unb.ca
'
' Press any key when drawing is complete, to exit.
'

REM $OPTION Y+

DEFINT a-z

SCREEN 1,640,400,LOG2(4),4
WINDOW 1,,(0,0)-(640,400),16+32+128+256,1

LogOf2# = LOG(2)

IterationsStable = 100
IterationsChaotic = 1000
xOrigin = 1
xSize = 639
yOrigin = 399
ySize = 380
rMin# = 2.85#
rMax# = 4#

PRINT "Logistic Formula";
COLOR 3
PRINT "         Fecundity (r)=                Iterations=";
LOCATE 1,44 : COLOR 1
PRINT USING "#.## - #.##"; rMin#,rMax#;
LOCATE 1,70
PRINT USING "#### / ####"; IterationsStable,IterationsChaotic;

xScale = xSize
rStep# = (rMax# - rMin#) / (ySize+1)
rChaotic# = 3.56994571869#

LINE (xOrigin, yOrigin)-(xOrigin-1, yOrigin-ySize-1),2,b
LINE (xOrigin, yOrigin)-(xOrigin + xSize, yOrigin),2

yChaotic = yOrigin - (rChaotic# - rMin#) / rStep#
LINE (xOrigin+1, yChaotic)-(xOrigin + xSize, yChaotic),3

r# = rMin#
FOR yCor = yOrigin TO yOrigin-ySize-1 STEP -1
        x# = .5
        total# = 0

        ' Eliminate transients
'       FOR n = 1 TO 50 : x# = (r# * x#) * (1-x#) : NEXT n

        ' Plot logistic system
        IF r# < rChaotic# THEN
                Iterations = IterationsStable
        ELSE
                Iterations = IterationsChaotic
        END IF

        FOR n = 1 TO Iterations
                x# = (r# * x#) * (1-x#)
                XCor = xOrigin + (x# * xScale)
                PSET (xCor,yCor)
        NEXT n

        r# = r# + rStep#
NEXT yCor


WHILE INKEY$ = "" : SLEEP : WEND
WINDOW CLOSE 1
SCREEN CLOSE 1

END
